import greenfoot.Actor;
import greenfoot.GreenfootImage;
import greenfoot.World;
import javax.imageio.ImageIO;
import java.io.File;
import java.awt.Color;
import java.awt.Point;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * Write a description of class FileHandler here.
 * 
 * @author Taylor Born
 * @version November 2011
 */
public class FileHandler extends Actor
{
    static HashMap<String, GreenfootImage> hm = new HashMap<String, GreenfootImage>();
    private boolean loading;
    private ListBox listBox = new ListBox(new Point(130, 50), new ArrayList<String>());
    private Button btnEnter = new Button("", new Point(44, 22));
    private Button btnCancel = new Button("Cancel", new Point(44, 22));
    private TextBox info = new TextBox(new Point(220, 80), "");
    private TextBox saveName = new TextBox(new Point(100, 14), "");
    private DropDownList ddl = new DropDownList(new ArrayList<String>(){{ add("png"); }}, 0);
    private boolean ready;

    public FileHandler()
    {
        info.setReadOnly(true);
        saveName.setMaxLength(10);
        saveName.acceptOnly("abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ");
    }
    public void load(boolean load)
    {
        loading = load;
        btnEnter.setText(load ? "Load" : "Save");
        if (load)
        {
            listBox.clear();
            info.setText("Choose a file to open");
            try
            {
                String[] files = new File("images/Saved/").list();
                for (int i = 0; i < files.length; i++)
                    if (okayFile("Saved/" + files[i]))
                        listBox.addString(files[i]);
                
            }
            catch (Exception e)
            {
                for (String s : hm.keySet())
                    listBox.addString(s);
            }
            listBox.setIndex(-1);
        }
        else
        {
            boolean saveable = false;
            try
            {
                String[] files = new File("images/Saved/").list();
                saveable = true;
            }
            catch (Exception e)
            {}
            info.setText("Choose a file name to save your image.\n\n" + (saveable ? "Your image will be saved in the folder images/Saved/" : "It is detected that your image will not save to any location other than the memory of the program."));
            saveName.setText("");
        }
    }
    public void act() 
    {
        GreenfootImage pic = new GreenfootImage(250, 200);
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
        
        setImage(pic);
        if (btnEnter.wasClicked() && (loading ? listBox.hasSelection() : saveName.getText().length() != 0))
        {
            ready = true;
            removeFromWorld();
        }
        else if (btnCancel.wasClicked())
            removeFromWorld();
    }
    public boolean isLoading()
    {
        return loading;
    }
    public boolean isReady()
    {
        boolean r = ready;
        ready = false;
        return r;
    }
    public void save(GreenfootImage image)
    {
        String name = saveName.getText() + "." + ddl.getSelected();
        try
        {
            ImageIO.write(image.getAwtImage(), ddl.getSelected(), new File("images/Saved/" + name));
        }
        catch (Exception ex)
        {
            hm.put(name, image);
        }
    }
    public GreenfootImage getImageLoaded()
    {
        String s = listBox.getOneSelection();
        if (hm.containsKey(s))
            return new GreenfootImage(hm.get(s));
        return new GreenfootImage("Saved/" + s);
    }
    public boolean okayFile(String s)
    {
        try
        {
            new GreenfootImage(s);
            return true;
        }
        catch (Exception e)
        {}
        return false;
    }
    public void addedToWorld(World world)
    {
        if (loading)
            world.addObject(listBox, getX(), getY() + 20);
        else
        {
            world.addObject(saveName, getX() - 125 + 50 + 50, getY());
            world.addObject(ddl, getX() + 55, getY());
        }
        world.addObject(btnEnter, getX() - 30, getY() + 85);
        world.addObject(btnCancel, getX() + 30, getY() + 85);
        world.addObject(info, getX(), getY() - 55);
    }
    public void removeFromWorld()
    {
        getWorld().removeObject(listBox);
        getWorld().removeObject(saveName);
        getWorld().removeObject(ddl);
        getWorld().removeObject(btnEnter);
        getWorld().removeObject(btnCancel);
        getWorld().removeObject(info);
        getWorld().removeObject(this);
    }
}