import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.awt.Color;

/**
 * Write a description of class PropertyPanel here.
 * 
 * @author Taylor Born
 * @version November 2011
 */
public class PropertyPanel extends Actor
{
    private TextBox txtPosX = new TextBox(new Point(60, 14), "");
    private TextBox txtPosY = new TextBox(new Point(60, 14), "");
    private TextBox txtWidth = new TextBox(new Point(60, 14), "");
    private TextBox txtHeight = new TextBox(new Point(60, 14), "");
    private int focusAt = -1;

    public PropertyPanel()
    {
        txtPosX.acceptOnly("-0123456789");
        txtPosY.acceptOnly("-0123456789");
        txtWidth.acceptOnly("0123456789");
        txtHeight.acceptOnly("0123456789");
    }
    public void act()
    {
        GreenfootImage pic = new GreenfootImage(130, 70);
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
        pic.drawString("Position (x, y)", 3, 14);
        pic.drawString("Size (width, height)", 3, 50);
        setImage(pic);
        
        if (Greenfoot.isKeyDown("enter"))
        {
            txtPosX.removeFocus();
            txtPosY.removeFocus();
            txtWidth.removeFocus();
            txtHeight.removeFocus();
        }
        
        if (txtPosX.focused())
            checkFocus(0);
        else if (txtPosY.focused())
            checkFocus(1);
        else if (txtWidth.focused())
            checkFocus(2);
        else if (txtHeight.focused())
            checkFocus(3);
        else
            checkFocus(-1);
    }
    private void checkFocus(int n)
    {
        if (n == focusAt)
            return;
        TextBox tb = null;
        switch (focusAt)
        {
            case 0: tb = txtPosX; break;
            case 1: tb = txtPosY; break;
            case 2: tb = txtWidth; break;
            default: tb = txtHeight;
        }
        try
        {
            Integer.parseInt(tb.getText());
        }
        catch (Exception e)
        {
            tb.setText("0");
        }
        int nn = Integer.parseInt(tb.getText());
        if (focusAt > 1)
            if (nn == 0)
                tb.setText("1");
            else if (nn > 1000)
                tb.setText("1000");
        Screen.main.updateByProperty(focusAt, nn);
        
        focusAt = n;
    }
    public void update(int x, int y, int w, int h)
    {
        txtPosX.setText(x + "");
        txtPosY.setText(y + "");
        txtWidth.setText(w + "");
        txtHeight.setText(h + "");
    }
    public void translate(int x, int y, int w, int h)
    {
        txtPosX.setText((Integer.parseInt(txtPosX.getText()) + x) + "");
        txtPosY.setText((Integer.parseInt(txtPosY.getText()) + y) + "");
        txtWidth.setText((Integer.parseInt(txtWidth.getText()) + w) + "");
        txtHeight.setText((Integer.parseInt(txtHeight.getText()) + h) + "");
    }
    public void addedToWorld(World world)
    {
        world.addObject(txtPosX, getX() - 31, getY() - 11);
        world.addObject(txtPosY, getX() + 31, getY() - 11);
        world.addObject(txtWidth, getX() - 31, getY() + 25);
        world.addObject(txtHeight, getX() + 31, getY() + 25);
    }
    public void removeFromWorld()
    {
        getWorld().removeObject(txtPosX);
        getWorld().removeObject(txtPosY);
        getWorld().removeObject(txtWidth);
        getWorld().removeObject(txtHeight);
        getWorld().removeObject(this);
    }
}