import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.awt.Color;

/**
 * Write a description of class SizeInputPanel here.
 * 
 * @author Taylor Born
 * @version November 2011
 */
public class SizeInputPanel extends Actor
{
    private TextBox inputX = new TextBox(new Point(40, 14), "300");
    private TextBox inputY = new TextBox(new Point(40, 14), "250");
    private Button btnEnter = new Button("Enter", new Point(44, 22));
    private Button btnCancel = new Button("Cancel", new Point(44, 22));
    private boolean ready = false;
    private Point size;

    public SizeInputPanel()
    {
        inputX.setMaxLength(3);
        inputX.acceptOnly("0123456789");
        inputY.setMaxLength(3);
        inputY.acceptOnly("0123456789");
    }
    public void act()
    {
        GreenfootImage pic = new GreenfootImage(200, 66);
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
        pic.drawString("Width:", 5, 20);
        pic.drawString("Height:", 102, 20);
        setImage(pic);
        
        boolean close = true;
        if (btnEnter.wasClicked())
        {
            ready = true;
            size = new Point(inputX.getText().length() == 0 ? 1 : Integer.parseInt(inputX.getText()), inputY.getText().length() == 0 ? 1 : Integer.parseInt(inputY.getText()));
            size.translate(size.getX() == 0 ? 1 : 0, size.getY() == 0 ? 1 : 0);
        }
        else if (!btnCancel.wasClicked())
            close = false;
        if (close)
        {
            getWorld().removeObject(inputX);
            getWorld().removeObject(inputY);
            getWorld().removeObject(btnEnter);
            getWorld().removeObject(btnCancel);
            getWorld().removeObject(this);
        }
    }
    
    public void addedToWorld(World world)
    {
        world.addObject(inputX, getX() - 32, getY() - 18);
        world.addObject(inputY, getX() + 72, getY() - 18);
        world.addObject(btnEnter, getX() - 25, getY() + 10);
        world.addObject(btnCancel, getX() + 25, getY() + 10);
    }
    
    public Point getSize()
    {
        return size;
    }
    
    public boolean hasSizeReady()
    {
        boolean r = ready;
        ready = false;
        return r;
    }
}